package kareltherobot;

class Adder extends Finder {

	Carrier Carry = new Carrier(1, 1, East, infinity);
	Checker Check = new Checker(1, 2, East, 0);
	
	public Adder(int street, int avenue, int direction, int howmany) {
	
		super(street, avenue, direction, howmany);
	}
	// insert new methods here

	void gatherHelpers() {
		Check.moveToRobot();
		Check.turnLeft();
		Carry.moveToRobot();
		Carry.turnLeft();
	}
	
	void addColumn() {
		move();
		pickAllBeepers();
		turnAround();
		findWall();
		turnAround();
		putAllBeepers();
		
		while (Check.enoughToCarry()) {
			Carry.carryOne();
		}
	}
	
	void slideLeft() {
		turnLeft();
		move();
		turnRight();
		Carry.turnLeft();
		Carry.move();
		Carry.turnRight();
		Check.turnLeft();
		Check.move();
		Check.turnRight();
	}
	
	boolean onSecondAve() {
		turnLeft();
		move();
		if(frontIsClear()) {
			turnAround();
			move();
			turnLeft();
			return false;
		} else {
			turnAround();
			move();
			turnLeft();
			return true;
		}
	}
	
	void addAll() {
		while (! onSecondAve()) {
			addColumn();
			slideLeft();
		}
		addColumn();
		slideLeft();
		move();
		Carry.move();
		Check.move();
	}		
			
}